
/*------------------------------------------------------------------
|																	|
|	PathFinder														|
|																	|
 --------------------------------------------------------------------*/
class PathFinder
{
	err          = 0;
	path         = false;
	retry_find   = false;	
	plan_retries = 0;
	path_len     = 0;
	constructor() {
		err          = AIError.ERR_NONE;
		path         = false;
		retry_find   = false;	
		plan_retries = 0;
		path_len     = 0;
	}
	function Plan(tile1, tile2);
}

/*------------------------------------------------------------------*/
function PathFinder::Plan(start, target)
{
	local pathfinder = RoadPathFinder();
	local plan_success = false;

	path = false;

	if(start == null || target == null)	{
		AILog.Info("PathFinder: BuildRoad: null tiles");
		retry_find = true;
		return false;
	}

	if( !AIMap.IsValidTile(start) || !AIMap.IsValidTile(target)) {
		AILog.Info("PF:Plan: no valid tile " + start + " " + target );
		retry_find = true;
		return false;
	}	

	retry_find = false;

	pathfinder.InitializePath([start], [target]);
	pathfinder.cost.slope = 150;

	while (path == false) {
	  path = pathfinder.FindPath(250);
	}
//	AILog.Info("PathFinder: FindPath ready " + (path != null));
	if (path == null){
		AILog.Info("PathFinder: Plan failed " + AIError.GetLastErrorString());

		err = AIError.GetLastError();
		switch (err) {
			/* ignore these errors */
			case AIError.ERR_NONE: 	
			case AIError.ERR_ALREADY_BUILT: 
				AILog.Info("Plan road:"+ AIError.GetLastErrorString());
				plan_success = true;
			break;
			case AIError.ERR_NOT_ENOUGH_CASH:  
				AILog.Info("Plan road failed (no cash)"+ AIError.GetLastErrorString());
			break;
			default:
				AILog.Info("Plan road failed (replan)"+ AIError.GetLastErrorString());	
				retry_find = true;
			break;
		} 
	} else {
		plan_success = true;
	}
	return (plan_success);
}
