
/*------------------------------------------------------------------
|																	|
|	RailPathFinder														|
|																	|
 --------------------------------------------------------------------*/
class RailPathFinder
{
	err          = 0;
	path         = false;
	retry_find   = false;	
	_use_existing   = false;	
	plan_retries = 0;
	path_len     = 0;
	constructor(use_existing = false) {
		_use_existing = use_existing;
		err          = AIError.ERR_NONE;
		path         = false;
		retry_find   = false;	
		plan_retries = 0;
		path_len     = 0;
	}
	function Plan(tile1, tile2);
}

/*------------------------------------------------------------------*/
function RailPathFinder::Plan(start, target, ignore, max_iters = 15000)
{
//	local pathfinder = RPathFinder();
	local pathfinder = Rail(_use_existing);
	local plan_success = false;

	path = false;

	if(start == null || target == null)	{
		AILog.Info("PathFinder: BuildRoad: null tiles");
		retry_find = true;
		return false;
	}


//AISign.BuildSign(start[0][0],"strt");
//AISign.BuildSign(target[0][0],"tar");
	retry_find = false;
	pathfinder.InitializePath(start, target, ignore);

	pathfinder.cost.slope = 50;
	pathfinder._multiplier = 1.5;
	local num = 0;
	while ((path == false) && (num < max_iters)) {
	  path = pathfinder.FindPath(250);
	  num += 250;
	}

	AILog.Info("PathFinder: FindPath ready " + num);
	if (path == false){
		return false;  // no path found in allowed nof iterations, no retry
	}
	if (path == null){
		AILog.Info("PathFinder: Plan failed " + AIError.GetLastErrorString());

		err = AIError.GetLastError();
		switch (err) {
			/* ignore these errors */
			case AIError.ERR_NONE:
				retry_find = true;			
				break;
			case AIError.ERR_ALREADY_BUILT: 
//				AILog.Info("Plan rail:"+ AIError.GetLastErrorString());
				plan_success = true;
			break;
			case AIError.ERR_NOT_ENOUGH_CASH:  
				AILog.Info("Plan rail failed (no cash)"+ AIError.GetLastErrorString());
				retry_find = true;			
			break;
			default:
				AILog.Info("Plan rail failed (replan)"+ AIError.GetLastErrorString());	
				retry_find = true;
			break;
		} 
	} else {
		plan_success = true;
	}
	return (plan_success);
}
