
/*------------------------------------------------------------------
|																	|
|	RailStation															|
|																	|
 ------------------------------------------------------------------*/

class RailStation
{
	_location = null;
	_build_succes = RailBuilder.FAIL;
	_length	= 0;
	_width  = 0;
	_connected_at_top = true;
	constructor(location) {
		_location = location;	
		_build_succes = RailBuilder.FAIL;
	}	
	function SetSize(width, length);
}

function RailStation::SetSize(width, length)
{
	_width = width;
	_length = length;
}

function RailStation::GetNewConnectionPoint()
{
	local tl = AITileList();
	local conn_point = [_location - 1, _location]; // tile to build, station tile
	
	tl.AddRectangle(conn_point[0], conn_point[0] + AIMap.GetTileIndex(-1, 1));
	local tile;
	local dum;
	foreach (tile, dum in tl){
		if (!AITile.IsBuildable(tile) || AIRoad.IsRoadTile(tile)) {
			conn_point[0] += (_length + 1);
			conn_point[1] += (_length - 1);
			_connected_at_top = false;
			break;
		}
	}
	return conn_point;
}	

function RailStation::GetNextConnectionPoint()
{
	local tl = AITileList();
	local conn_point = [_location - 1, _location]; // tile to build, station tile

	conn_point[0] += AIMap.GetTileIndex(0, 1);
	conn_point[1] += AIMap.GetTileIndex(0, 1);
	
	if (!_connected_at_top){
		conn_point[0] += (_length + 1);
		conn_point[1] += (_length - 1);
	}
	
	return conn_point;
}

