
/*------------------------------------------------------------------
|																	|
|	RoutePlanner													|
|																	|
 --------------------------------------------------------------------*/
class RoutePlanner
{
	town_list             = null;
	town_list2            = null;
	town_acc_list         = null;
	town_train_acc_list    = null;
	state                 = 0;
	cargo_id              = 0;
	date_town_acc_update  = 0;
	date_town_train_acc_update  = 0;
	constructor(pass_cargo_id) {
		this.cargo_id      = pass_cargo_id;
		this.town_list     = null;
		this.town_list2    = null;
		this.town_acc_list = null;
		this.town_train_acc_list = null;
		this.state         = 0;
		date_town_acc_update  = 0;
		date_town_train_acc_update  = 0;
	}
	function FindUnusedTowns(agressive);
	function InitTownList();
	function UpdateTownAcceptanceList();
}


/*------------------------------------------------------------------*/
function RoutePlanner::InitTownList()
{
	this.town_list2 = AITownList(); 
	this.town_list  = AIList();
	this.town_list.AddList(this.town_list2);
	town_list.Valuate(AITown.GetPopulation);
	this.town_acc_list = AIList();
	this.town_train_acc_list = AIList();
}


/*------------------------------------------------------------------*/
function RoutePlanner::UpdateTownBusAcceptanceList()
{
	AILog.Info("Update town acceptance list");
	if (AIDate.GetCurrentDate() - date_town_acc_update > 60)	{
		town_acc_list.Clear();
		foreach ( twn, v in town_list){
			local acc = TownManager.EstimateAcceptanceBus(twn, cargo_id);
			if (acc){
				town_acc_list.AddItem(twn, acc[0]);
			}	
		 	AIController.Sleep(1);
		}
		date_town_acc_update = AIDate.GetCurrentDate();
	}
}

/*------------------------------------------------------------------*/
function RoutePlanner::UpdateTownTrainAcceptanceList()
{
	AILog.Info("Update town train acceptance list");
	if (AIDate.GetCurrentDate() - date_town_train_acc_update > 60)	{
		town_train_acc_list.Clear();
		foreach ( twn, v in town_list){
			local acc = TownManager.EstimateAcceptanceTrain(twn, cargo_id);
			if (acc){
				town_train_acc_list.AddItem(twn, acc[0]);
			}	
		 	AIController.Sleep(1);
		}
		date_town_train_acc_update = AIDate.GetCurrentDate();
	}
	AILog.Info("Update town train acceptance list" + town_train_acc_list.Count());
}

/*------------------------------------------------------------------*/
function RoutePlanner::FindUnusedTowns(agressive, bus)
{
	local town    = 0;
	local town2   = 0;
	local town_it = AITown();
	local found   = false;

	AILog.Info("Find unused towns agressive: " + agressive);

	if (bus) {
		UpdateTownBusAcceptanceList();			
		if (town_acc_list.Count()){
			for (town_it = town_acc_list.Begin(); town_acc_list.HasNext(); 
  				town_it = town_acc_list.Next()){
				AILog.Info("acceptance of " + AITown.GetName(town_it) + " = " + town_acc_list.GetValue(town_it));					
				local tl2 = AITileList();
				/* On agressive setting, build wherever you can to make money, 
				 * On not-agressive setting, keep away from the towns where a player already built a station
				 */
				if (!agressive){
					tl2.AddRectangle(AITown.GetLocation(town_it) + AIMap.GetTileIndex(-8, -8),
									 AITown.GetLocation(town_it) + AIMap.GetTileIndex(8, 8));
					tl2.Valuate(AIRoad.IsRoadStationTile);
					tl2.KeepValue(1);
				}	
				if (!tl2.Count()){
					town = town_it;
					found = true;
					town_acc_list.RemoveItem(town);
					break;
				}
			}	

			if (found) {
				found = false;
//				AILog.Info("Find unused towns, find second town");
				town_list2.Clear();
				town_list2.AddList(town_list);
				town_list2.Valuate(AITown.GetDistanceManhattanToTile, AITown.GetLocation(town));
				town_list2.KeepBetweenValue(40,80);
				if (!town_list2.Count()){
					town_list2.AddList(town_list);
					town_list2.Valuate(AITown.GetDistanceManhattanToTile, AITown.GetLocation(town));
					town_list2.KeepBetweenValue(20,100);
					if (!town_list2.Count()){
						town_list2.AddList(town_list);
						town_list2.Valuate(AITown.GetDistanceManhattanToTile, AITown.GetLocation(town));
						town_list2.KeepBetweenValue(10,150);
					}	
				}
				local town_list3 = AIList();

				foreach ( twn, v in town_list2){
					local acc = TownManager.EstimateAcceptanceBus(twn, cargo_id);
					town_list3.AddItem(twn, acc[0]);
					AIController.Sleep(1);
				}
				if (town_list3.Count()) {
					for (town_it = town_list3.Begin(); town_list3.HasNext(); 
								town_it = town_list3.Next()){
						if (town_it != town) {	
							local tl2 = AITileList();
							/* On agressive setting, build wherever you can to make money, 
							 * On not-agressive setting, keep away from the towns where a player already built a station	
							 */  
							if (!agressive){
								tl2.AddRectangle(	AITown.GetLocation(town_it) + AIMap.GetTileIndex(-8, -8),
														AITown.GetLocation(town_it) + AIMap.GetTileIndex(8, 8));
								tl2.Valuate(AIRoad.IsRoadStationTile);
								tl2.KeepValue(1);
							}
							if (!tl2.Count()){
								town2 = town_it;
								found = true;
								break;
							}
							else {
								found = false;
								AILog.Info("Find unused towns, find second town: not found");
							}
						}
					}
				}
			}		
		} else return null;
	} else{
		UpdateTownTrainAcceptanceList();			
		if (town_train_acc_list.Count()){
			for (town_it = town_train_acc_list.Begin(); town_train_acc_list.HasNext(); 
				town_it = town_train_acc_list.Next()){
				AILog.Info("acceptance of " + AITown.GetName(town_it) + " = " + town_train_acc_list.GetValue(town_it));					
				local tl2 = AITileList();
				/* On agressive setting, build wherever you can to make money, 
				 * On not-agressive setting, keep away from the towns where a player already built a station
				 */
				if (!agressive){
					tl2.AddRectangle(AITown.GetLocation(town_it) + AIMap.GetTileIndex(-8, -8),
									 AITown.GetLocation(town_it) + AIMap.GetTileIndex(8, 8));
					tl2.Valuate(AIRoad.IsRoadStationTile);
					tl2.KeepValue(1);
				}	
				if (!tl2.Count()){
					town = town_it;
					found = true;
					town_train_acc_list.RemoveItem(town);
					break;
				}
			}	

			if (found) {
				found = false;
//				AILog.Info("Find unused towns, find second town");
				town_list2.Clear();
				town_list2.AddList(town_list);
				town_list2.Valuate(AITown.GetDistanceManhattanToTile, AITown.GetLocation(town));
				town_list2.KeepBetweenValue(80,200);
				if (!town_list2.Count()){
					town_list2.AddList(town_list);
					town_list2.Valuate(AITown.GetDistanceManhattanToTile, AITown.GetLocation(town));
					town_list2.KeepBetweenValue(40,250);
					if (!town_list2.Count()){
						town_list2.AddList(town_list);
						town_list2.Valuate(AITown.GetDistanceManhattanToTile, AITown.GetLocation(town));
						town_list2.KeepBetweenValue(20,300);
					}	
				}
				local town_list3 = AIList();

				foreach ( twn, v in town_list2){
					local acc = TownManager.EstimateAcceptanceTrain(twn, cargo_id);
					town_list3.AddItem(twn, acc[0]);
					AIController.Sleep(1);
				}
				if (town_list3.Count()) {
					for (town_it = town_list3.Begin(); town_list3.HasNext(); 
								town_it = town_list3.Next()){
						if (town_it != town) {	
							local tl2 = AITileList();
							/* On agressive setting, build wherever you can to make money, 
							 * On not-agressive setting, keep away from the towns where a player already built a station	
							 */  
							if (!agressive){
								tl2.AddRectangle(	AITown.GetLocation(town_it) + AIMap.GetTileIndex(-8, -8),
														AITown.GetLocation(town_it) + AIMap.GetTileIndex(8, 8));
								tl2.Valuate(AIRoad.IsRoadStationTile);
								tl2.KeepValue(1);
							}
							if (!tl2.Count()){
								town2 = town_it;
								found = true;
								break;
							}
							else {
								found = false;
								AILog.Info("Find unused towns, find second town: not found");
							}
						}
					}
				}
			}		
		} else return null;
	}

	if (found) {
		return [ town, town2 ];
	}
	else {
		return null;
	}
}